#include "nrlolsrApp.h"

NrlolsrApp::NrlolsrApp() : nrlolsrObject(GetSocketNotifier(),GetTimerMgr())
{
}

bool 
NrlolsrApp::OnStartup(int argc, const char*const* argv)
{
  DMSG(0,"Enter: NrlolsrApp::OnStartup(argc,argv)\n");
  routingTable=ProtoRouteMgr::Create(); 
  if(routingTable){
    if(!routingTable->Open()){
      DMSG(0,"NrlolsrApp::OnStartup: Error Opening routing table\n");
      return false;
    }
  } else {
    DMSG(0,"NrlolsrApp::OnStartup: Error creating routing table\n");
    return false;
  }
  nrlolsrObject.SetOlsrRouteTable(routingTable);
  if(ProcessCommands(argc,argv)){
    nrlolsrObject.Start();
  } else {
    DMSG(0,"Error parsing commands in NrlolsrApp::OnStartup()\n");
    return false;
  }
  return true;
}

bool 
NrlolsrApp::ProcessCommands(int argc, const char*const* argv)
{
  return  nrlolsrObject.ProcessCommands(argc,argv);
}
void 
NrlolsrApp::OnShutdown()
{
  nrlolsrObject.Stop();
  routingTable->Close();
  delete routingTable;
  routingTable=NULL;
  return;
}

//void
//NrlolsrApp::recv(Packet *p,Handler *)
//{
//  //check packets with port 689 and to socket recv of nrlolsrObject
//  //check destination with routingTable for next hop and send out to next hop
//  return;
//}

PROTO_INSTANTIATE_APP(NrlolsrApp)

