#ifndef _OPNET_OLSR_PROCESS
#define _OPNET_OLSR_PROCESS

#include "opnet.h"
#include "opnetProtoSimProcess.h"
#include "nrlolsr.h" // this includes protokit.h
#include "OpnetProtoRouteMgr.h"


class OpnetOlsrProcess : public OpnetProtoSimProcess, public Nrlolsr
{
    public:
    // Construction
        // LP 6-17-04 - replaced to test
		// OpnetOlsrProcess()  : Nrlolsr(GetSocketNotifier(),GetTimerMgr()) {}; 
		OpnetOlsrProcess()  : Nrlolsr(GetSocketNotifier(),GetTimerMgr()) {
			  printf("OpnetOlsrProcess.h - OpnetOlsrProcess() - this = %ld\n", this);
			  }

		~OpnetOlsrProcess();
	
	unsigned long GetAgentId() 
		{return ((unsigned long) node_id);} //  virtual MDPSimAgent function  

	
	// OpnetProtoSimProcess's virtual functions
	bool OnStartup(int argc, const char*const* argv);
	bool ProcessCommands(int argc, const char*const* argv);
	void OnShutdown(); 
	void SetOlsrNodeId (int nodeId) {node_id = nodeId;}  
	int GetOlsrNodeId () {return node_id;}  // LP 6-17-04 - added

	IpT_Address GetRoute(SIMADDR dest);
	bool GetLocalAddress(ProtoAddress& localAddr); 
	void OnReceive(Packet * rcv_pkt); 
	bool InitializeRoutingTable();
	
	private:
    // Members
		double        client_start_time;
		int			  node_id;  
		bool			logging;
	
		friend class OpnetProtoRouteMgr;
		OpnetProtoRouteMgr* routingTable_mgr;

};  // end class OpnetOlsrProcess

#ifdef PROTO_DEBUG
// This routine produces a timestamped trace of MDP messages
// void MessageTrace(bool send, unsigned long node_id, MdpMessage *msg, int len, const ProtoAddress *src);

void SetOlsrMessageTrace(bool state);
#endif // PROTO_DEBUG


#endif // _OPNET_OLSR_PROCESS


